import com.ibm.bsf.*;   // BSF support
// import org.apache.bsf.*;   // BSF support

/**
 * @author   Rony G. Flatscher, 2001-04-18
 */
public class TestRGF {

   /** Static test field #1 (an integer). */
   public static int statField1 = 2001;

   private static int statField99 = 99;
   private        int instField99 = -99;

   /** Static test field #2 (an Object).*/
   static Object statField2 = new Object();

   /** Static test field #3 (an array of Strings). */
   public static String [] statField3 = { "eins", "zwei", "drei" };


   /** Static test field #4, 2-dimensional array (6x2). */
   public static String statField4[][]= new String [6][2] ;

   /** Static test field #5, 3-dimensional array (6x2x3). */
   public static String statField5[][][]= new String [6][2][3] ;

   /** Static test field #6, 4-dimensional array (6x2x3x4). */
   public static String statField6[][][][]= new String [6][2][3][4] ;

   /** Static test field #7, 5-dimensional array (6x2x3x4x5). */
   public static String statField7[][][][][]= new String [6][2][3][4][5] ;


   /** Instance test field #1 (an integer). */
   public int instField1 = 8009;

   /** Instance test field #2 (an Object).*/
   public Object instField2 = new Object();

   Object instField4 = new Object();

   /** Instance test field #3 (an array of Strings). */
   public String instField3 [] = { "zehn", "neun", "acht" };


  /** testing calling Rexx  */
  public static void main (String[] args)
  {
     System.out.println("In TestRGF.java, args.length="+args.length);
     if (args.length==0) return;        // do not proceed!
     System.out.println("\targs[0]=["+args[0]+"]");

    try
    {

      BSFManager mgr    = new BSFManager ();
      BSFEngine  rexxEngine = mgr.loadScriptingEngine("rexx");
      String     code   = "call " + args[0];    // expecting filename as argument

      {
         Object obj = rexxEngine.call ("Testing calling Rexx ...", code, null);

         System.err.println("\n\t---\n");
         System.err.println("Result: [" + obj + "]");
      }
    }
    catch (BSFException e)
    {
      e.printStackTrace();
    }
 }

  public static int getStatField1()
  {
      return statField1;
  }

  public static int getStatField99()
  {
      return statField99;
  }

  public int getInstField1()
  {
     return instField1;
  }

  public int getInstField99()
  {
     return instField99;
  }

  public static void setStatField1(int value)
  {
      statField1=value;
  }

  public static void setStatField99(int value)
  {
      statField99=value;
  }

  public void setInstField1(int value)
  {
      instField1=value;
  }

  public void setInstField99(int value)
  {
      instField99=value;
  }

  public String toString()
  {
     return
     "Static:  \n\t sF1: ["+statField1+"],\n\t sF2: ["+statField2+"], \n\t sF3: ["+statField3+"]"+
     "\nInstance:\n\t iF1: ["+instField1+"],\n\t iF2: ["+instField2+"], \n\t iF3: ["+instField3+"]";
  }

  public void dump()
  {
     System.out.println(toString());
  }

}

