parse version version
say 'Rexx interpreter: ' pp(version)
say 'BSF4Rexx (DLL/so):' pp(bsfVersion())
say 'Java Rexx engine: ' pp(bsf("version"))
say 'BSF.CLS version:  ' pp(.bsf4rexx~version)
say

say center(" routine 'test', which dumps the condition object ", 79, "=")
say "BsfShowErrorMessage():" pp(BsfShowErrorMessage())
call test
say "-"~copies(20)

call BsfShowErrorMessage 0 -- switch off printing the stack trace
say "BsfShowErrorMessage():" pp(BsfShowErrorMessage())
call test
say "-"~copies(20)

say center(" routine 'test2', which shows 'BSF_ERROR_MESSAGE' ", 79, "=")
say "BsfShowErrorMessage(1):" pp(BsfShowErrorMessage(1))
call test2
say "-"~copies(20)

say "BsfShowErrorMessage(0):" pp(BsfShowErrorMessage(0))
call test2
say "-"~copies(20)

say center(" routine 'test3', which shows nothing on its own ", 79, "=")
say "BsfShowErrorMessage(1):" pp(BsfShowErrorMessage(1))
call test3
say "-"~copies(20)

say "BsfShowErrorMessage(0):" pp(BsfShowErrorMessage(0))
call test3
say "-"~copies(20)


::requires "BSF.CLS"


  -- force an error on the Java side
::routine test

  signal on syntax

  s=box("String", "Hello, world")
  say s~toString        -- o.k.
  say s~hiDearWorld

  return

syntax:     -- target
  co=condition('o')
  say "SYNTAX condition has occurred, variable 'BSF_ERROR_MESSAGE':"
  say pp(bsf_error_message)-- variable "BSF_ERROR_STRING" gets set by BSF() and contains
  say

  call dumpConditionObject(co)
  return


  -- force an error on the Java side
::routine test2

  signal on syntax

  s=box("String", "Hello, world")
  say s~toString        -- o.k.
  say s~Another_non_existing_method(.bsf~bsf.import("java.lang.Object")~new,         -
                                    .bsf~bsf.import("java.lang.Integer")~new(12345) )

  return

syntax:     -- target
  co=condition('o')
  say "SYNTAX condition has occurred, variable 'BSF_ERROR_MESSAGE':"
  say pp(bsf_error_message)-- variable "BSF_ERROR_STRING" gets set by BSF() and contains
  say
  return

  -- force an error on the Java side
::routine test3

  signal on syntax

  s=box("String", "Hello, world")
  say s~toString        -- o.k.
  say s~WOW_yet_another_error("hello", 13*57, "oops!")

  return

syntax:     -- target
  return


::routine dumpConditionObject
  use arg co

  tab="09"x             -- define tabulator character
                           -- the Java exception message
  say tab "Dumping condition object:"
  say

  do i over co          -- iterate over condition object
     o=co~at(i)         -- get object for entry in hand
     say tab pp(i)":" pp(o~string)

     if o~hasmethod("ITEMS") then
     do k over o        -- iterate over collection
        say tab tab pp(k~string)
     end
  end
  return

